"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createUseSignalREffect = void 0;
const hermes_channel_1 = __importDefault(require("hermes-channel"));
const react_1 = require("react");
const utils_1 = require("../utils");
const utils_2 = require("./utils");
function createUseSignalREffect(context) {
    const useSignalREffect = (callback) => {
        const callbackRef = (0, utils_1.useEvent)(callback);
        (0, react_1.useEffect)(() => {
            function _callback(data) {
                callbackRef(data);
            }
            hermes_channel_1.default.on((0, utils_2.getMessageEvent)(context), _callback);
            return () => {
                hermes_channel_1.default.off((0, utils_2.getMessageEvent)(context), _callback);
            };
            // eslint-disable-next-line react-hooks/exhaustive-deps
        }, []);
    };
    return useSignalREffect;
}
exports.createUseSignalREffect = createUseSignalREffect;
//# sourceMappingURL=hooks.js.map